import { SYSTEM } from "../config/system.mjs"

export default class CthulhuEternalWeapon extends foundry.abstract.TypeDataModel {
  static defineSchema() {
    const fields = foundry.data.fields
    const schema = {}
    const requiredInteger = { required: true, nullable: false, integer: true }

    schema.description = new fields.HTMLField({ required: true, textSearch: true })

    let setting = game.settings.get("fvtt-cthulhu-eternal", "settings-era") || "modern"
    schema.settings = new fields.StringField({ required: true, initial: setting, choices: SYSTEM.AVAILABLE_SETTINGS })

    schema.weaponType = new fields.StringField({ required: true, initial: "melee", choices: SYSTEM.WEAPON_TYPE })
    schema.hasDirectSkill = new fields.BooleanField({ required: true, initial: false })
    schema.directSkillValue = new fields.NumberField({ required: true, initial: 0, min: 0, max:99 })
    
    schema.damage = new fields.StringField({required: true, initial: "1d6"})  
    schema.baseRange = new fields.StringField({required: true, initial: ""})
    schema.rangeUnit = new fields.StringField({ required: true, initial: "yard", choices: SYSTEM.WEAPON_RANGE_UNIT })
    schema.lethality = new fields.NumberField({ required: true, initial: 0, min: 0 })
    schema.killRadius = new fields.NumberField({ required: true, initial: 0, min: 0 })
    schema.armorPiercing = new fields.NumberField({ required: true, initial: 0, min: 0 })
    schema.weaponSubtype = new fields.StringField({ required: true, initial: "basicfirearm", choices: SYSTEM.WEAPON_SUBTYPE })  
    schema.state = new fields.StringField({ required: true, initial: "pristine", choices: SYSTEM.EQUIPMENT_STATES })

    schema.resourceLevel = new fields.NumberField({ required: true, initial: 0, min: 0 })
    
    return schema
  }

  /** @override */
  static LOCALIZATION_PREFIXES = ["CTHULHUETERNAL.Weapon"]

  get weaponCategory() {
    return game.i18n.localize(CATEGORY[this.category].label)
  }
}
